/*********************************************************
 * cube.c
 --------------------------------------------------------*/
/*--------------------------------------------------------
 * The following modelling data for each cubic-piece are 
 * taken from 
 *
 *   "rubik.c"  by mfvianna@centroin.com.br, 
 *
 * which can be found in the directory: ./reference
 --------------------------------------------------------*/

/*********************************************************
 * public function
 *
 * extern void draw_raw_cube(int N);
 * extern void put_stickers(int i, int N);
 *
 --------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <GL/glut.h>

#include "material.c"

GLfloat 
AA[9] ={0, 0, 0.480, 0.470, 0.465, 0.460, 0.455, 0.450, 0.450},
EE[9] ={0, 0, 0.460, 0.425, 0.415, 0.405, 0.400, 0.395, 0.390};

void draw_raw_cube(int N)
{
    GLfloat ll = 0.50;
    GLfloat aa = AA[N];

    setMaterial(Black);

    /* Faces of cube */
    glBegin(GL_QUADS);
    glNormal3f( 0.,  0.,  1.);
    glVertex3f(-aa, -aa,  ll);
    glVertex3f( aa, -aa,  ll);
    glVertex3f( aa,  aa,  ll);
    glVertex3f(-aa,  aa,  ll);

    glNormal3f( 0.,  0., -1.);
    glVertex3f(-aa,  aa, -ll);
    glVertex3f( aa,  aa, -ll);
    glVertex3f( aa, -aa, -ll);
    glVertex3f(-aa, -aa, -ll);

    glNormal3f(-1.,  0.,  0.);
    glVertex3f(-ll, -aa,  aa);
    glVertex3f(-ll,  aa,  aa);
    glVertex3f(-ll,  aa, -aa);
    glVertex3f(-ll, -aa, -aa);

    glNormal3f( 1.,  0.,  0.);
    glVertex3f( ll, -aa, -aa);
    glVertex3f( ll,  aa, -aa);
    glVertex3f( ll,  aa,  aa);
    glVertex3f( ll, -aa,  aa);

    glNormal3f( 0., -1.,  0.);
    glVertex3f( aa, -ll, -aa);
    glVertex3f( aa, -ll,  aa);
    glVertex3f(-aa, -ll,  aa);
    glVertex3f(-aa, -ll, -aa);

    glNormal3f( 0.,  1.,  0.);
    glVertex3f(-aa,  ll, -aa);
    glVertex3f(-aa,  ll,  aa);
    glVertex3f( aa,  ll,  aa);
    glVertex3f( aa,  ll, -aa);
    glEnd();

    /* Edges of cube */
    glBegin(GL_QUADS);
    glNormal3f(-1., -1.,  0.);
    glVertex3f(-aa, -ll, -aa);
    glVertex3f(-aa, -ll,  aa);
    glVertex3f(-ll, -aa,  aa);
    glVertex3f(-ll, -aa, -aa);
    
    glNormal3f( 1.,  1.,  0.);
    glVertex3f( aa,  ll, -aa);
    glVertex3f( aa,  ll,  aa);
    glVertex3f( ll,  aa,  aa);
    glVertex3f( ll,  aa, -aa);

    glNormal3f(-1.,  1.,  0.);
    glVertex3f(-ll,  aa, -aa);
    glVertex3f(-ll,  aa,  aa);
    glVertex3f(-aa,  ll,  aa);
    glVertex3f(-aa,  ll, -aa);

    glNormal3f( 1., -1.,  0.);
    glVertex3f( ll, -aa, -aa);
    glVertex3f( ll, -aa,  aa);
    glVertex3f( aa, -ll,  aa);
    glVertex3f( aa, -ll, -aa);

    glNormal3f( 0., -1., -1.);
    glVertex3f(-aa, -aa, -ll);
    glVertex3f( aa, -aa, -ll);
    glVertex3f( aa, -ll, -aa);
    glVertex3f(-aa, -ll, -aa);

    glNormal3f( 0.,  1.,  1.);
    glVertex3f(-aa,  aa,  ll);
    glVertex3f( aa,  aa,  ll);
    glVertex3f( aa,  ll,  aa);
    glVertex3f(-aa,  ll,  aa);

    glNormal3f( 0., -1.,  1.);
    glVertex3f(-aa, -ll,  aa);
    glVertex3f( aa, -ll,  aa);
    glVertex3f( aa, -aa,  ll);
    glVertex3f(-aa, -aa,  ll);

    glNormal3f( 0.,  1., -1.);
    glVertex3f(-aa,  ll, -aa);
    glVertex3f( aa,  ll, -aa);
    glVertex3f( aa,  aa, -ll);
    glVertex3f(-aa,  aa, -ll);

    glNormal3f(-1.,  0., -1.);
    glVertex3f(-ll, -aa, -aa);
    glVertex3f(-ll,  aa, -aa);
    glVertex3f(-aa,  aa, -ll);
    glVertex3f(-aa, -aa, -ll);

    glNormal3f( 1.,  0.,  1.);
    glVertex3f( ll, -aa,  aa);
    glVertex3f( ll,  aa,  aa);
    glVertex3f( aa,  aa,  ll);
    glVertex3f( aa, -aa,  ll);

    glNormal3f( 1.,  0., -1.);
    glVertex3f( aa, -aa, -ll);
    glVertex3f( aa,  aa, -ll);
    glVertex3f( ll,  aa, -aa);
    glVertex3f( ll, -aa, -aa);

    glNormal3f(-1.,  0.,  1.);
    glVertex3f(-aa, -aa,  ll);
    glVertex3f(-aa,  aa,  ll);
    glVertex3f(-ll,  aa,  aa);
    glVertex3f(-ll, -aa,  aa);
    glEnd();

    /* Corners of cube */
    glBegin(GL_TRIANGLES);
    glNormal3f( 1.,  1.,  1.);
    glVertex3f( aa,  aa,  ll);
    glVertex3f( ll,  aa,  aa);
    glVertex3f( aa,  ll,  aa);

    glNormal3f(-1., -1., -1.);
    glVertex3f(-aa, -ll, -aa);
    glVertex3f(-ll, -aa, -aa);
    glVertex3f(-aa, -aa, -ll);

    glNormal3f(-1.,  1.,  1.);
    glVertex3f(-aa,  aa,  ll);
    glVertex3f(-aa,  ll,  aa);
    glVertex3f(-ll,  aa,  aa);

    glNormal3f( 1., -1., -1.);
    glVertex3f( ll, -aa, -aa);
    glVertex3f( aa, -ll, -aa);
    glVertex3f( aa, -aa, -ll);

    glNormal3f( 1., -1.,  1.);
    glVertex3f( aa, -aa,  ll);
    glVertex3f( aa, -ll,  aa);
    glVertex3f( ll, -aa,  aa);

    glNormal3f(-1.,  1., -1.);
    glVertex3f(-ll,  aa, -aa);
    glVertex3f(-aa,  ll, -aa);
    glVertex3f(-aa,  aa, -ll);

    glNormal3f(-1., -1.,  1.);
    glVertex3f(-aa, -aa,  ll);
    glVertex3f(-ll, -aa,  aa);
    glVertex3f(-aa, -ll,  aa);

    glNormal3f( 1.,  1., -1.);
    glVertex3f( ll,  aa, -aa);
    glVertex3f( aa,  aa, -ll);
    glVertex3f( aa,  ll, -aa);
    glEnd();
}

void put_stickers(int i, int N)
{
    GLfloat dd = (N<4)? 0.505 : 0.510;
    GLfloat ee = EE[N];
    GLfloat ff = ee - ((N==2)?.02:.04);
    int j=(i%N), k=(i%(N*N))/N, l=(i/(N*N));

    if(j==0) { // -X
	setMaterial(Yellow);
	glBegin(GL_POLYGON);
	glNormal3f(-1.,  0.,  0.);
	glVertex3f(-dd, -ff,  ee);
	glVertex3f(-dd,  ff,  ee);
	glVertex3f(-dd,  ee,  ff);
	glVertex3f(-dd,  ee, -ff);
	glVertex3f(-dd,  ff, -ee);
	glVertex3f(-dd, -ff, -ee);
	glVertex3f(-dd, -ee, -ff);
	glVertex3f(-dd, -ee,  ff);
	glEnd();
    }
    if(j==N-1) { //  X
	setMaterial(Green);
	glBegin(GL_POLYGON);
	glNormal3f( 1.,  0.,  0.);
	glVertex3f( dd, -ff, -ee);
	glVertex3f( dd,  ff, -ee);
	glVertex3f( dd,  ee, -ff);
	glVertex3f( dd,  ee,  ff);
	glVertex3f( dd,  ff,  ee);
	glVertex3f( dd, -ff,  ee);
	glVertex3f( dd, -ee,  ff);
	glVertex3f( dd, -ee, -ff);
	glEnd();
    }
    if(k==0) { // -Y
	setMaterial(Orange);
	glBegin(GL_POLYGON);
	glNormal3f( 0., -1.,  0.);
	glVertex3f( ee, -dd, -ff);
	glVertex3f( ee, -dd,  ff);
	glVertex3f( ff, -dd,  ee);
	glVertex3f(-ff, -dd,  ee);
	glVertex3f(-ee, -dd,  ff);
	glVertex3f(-ee, -dd, -ff);
	glVertex3f(-ff, -dd, -ee);
	glVertex3f( ff, -dd, -ee);
	glEnd();
    }
    if(k==N-1) { //  Y 
	setMaterial(Red);
	glBegin(GL_POLYGON);
	glNormal3f( 0.,  1.,  0.);
	glVertex3f(-ee,  dd, -ff);
	glVertex3f(-ee,  dd,  ff);
	glVertex3f(-ff,  dd,  ee);
	glVertex3f( ff,  dd,  ee);
	glVertex3f( ee,  dd,  ff);
	glVertex3f( ee,  dd, -ff);
	glVertex3f( ff,  dd, -ee);
	glVertex3f(-ff,  dd, -ee);
	glEnd();
    }
    if (l==0) { // -Z
	setMaterial(Blue);
	glBegin(GL_POLYGON);
	glNormal3f( 0.,  0., -1.);
	glVertex3f(-ff,  ee, -dd);
	glVertex3f( ff,  ee, -dd);
	glVertex3f( ee,  ff, -dd);
	glVertex3f( ee, -ff, -dd);
	glVertex3f( ff, -ee, -dd);
	glVertex3f(-ff, -ee, -dd);
	glVertex3f(-ee, -ff, -dd);
	glVertex3f(-ee,  ff, -dd);
	glEnd();
    }
    if(l==N-1) { // Z
	setMaterial(White);
	glBegin(GL_POLYGON);
	glNormal3f( 0.,  0.,  1.);
	glVertex3f(-ff, -ee,  dd);
	glVertex3f( ff, -ee,  dd);
	glVertex3f( ee, -ff,  dd);
	glVertex3f( ee,  ff,  dd);
	glVertex3f( ff,  ee,  dd);
	glVertex3f(-ff,  ee,  dd);
	glVertex3f(-ee,  ff,  dd);
	glVertex3f(-ee, -ff,  dd);
	glEnd();
    }
}
/* -------------------------------------------------------- */
// End of cube.c 
