/*********************************************************
 * material.h
 --------------------------------------------------------*/
typedef struct material{
    GLfloat ambient [4];
    GLfloat diffuse [4];
    GLfloat specular[4];
    GLfloat shininess;
} Material;

extern void setMaterial(Material *);
extern Material
*Black, *White, *Blue, *Yellow, *Green, *Orange, *Red;
/*-------------------------------------------------------*/

void setMaterial(Material *mat)
{
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,   mat->ambient);
    glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,   mat->diffuse);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,  mat->specular);
    glMaterialf (GL_FRONT_AND_BACK, GL_SHININESS, mat->shininess*128);
}

/*******************************************************
 * Material DataBase
 ------------------------------------------------------*/
Material MatDB[16] = {
    {  //[00] black plastic;
       {0.0,  0.0,  0.0,  1.0},
       {0.1,  0.1,  0.1,  1.0},
       {0.7,  0.7,  0.7,  1.0},
       .55
    },{//[01] white plastic;
       {0.2,  0.2,  0.2,  1.0},
       {0.7,  0.7,  0.8,  1.0},
       {0.8,  0.8,  0.8,  1.0},
       .55
    },{//[02] blue plastic;
       {0.0,  0.0,  0.1,  1.0},
       {0.0,  0.0,  0.6,  1.0},
       {0.8,  0.8,  0.8,  1.0},
       .55
    },{//[03] yellow plastic;
       {0.2,  0.2,  0.0,  1.0},
       {0.7,  0.7,  0.0,  1.0},
       {0.8,  0.8,  0.8,  1.0},
       .55
    },{//[04] green plastic;
       {0.0,  0.1,  0.0,  1.0},
       {0.0,  0.4,  0.1,  1.0},
       {0.8,  0.8,  0.8,  1.0},
	.55
    },{//[05] orange plastic;
       {0.2,  0.0,  0.0,  1.0},
       {1.0,  0.1,  0.0,  1.0},
       {0.8,  0.8,  0.7,  1.0},
       .55
    },{//[06] red plastic;
       {0.0,  0.0,  0.0,  1.0},
       {0.7,  0.0,  0.0,  1.0},
       {0.8,  0.8,  0.8,  1.0},
       .55
    }
};

Material *Black =&MatDB[0];
Material *White =&MatDB[1];
Material *Blue  =&MatDB[2];
Material *Yellow=&MatDB[3];
Material *Green =&MatDB[4];
Material *Orange=&MatDB[5];
Material *Red   =&MatDB[6];
